=== debian/changelog ===
oclgrind (15.5-3build1) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 15:54:12 +0000

oclgrind (15.5-3) unstable; urgency=low

  * Use opencl-headers instead of local copy of CL/*.h
  * Use -std=gnu++11 to fix AltiVec issues (Closes: #806965)

 -- James Price <j.price@bristol.ac.uk>  Wed, 16 Dec 2015 00:35:15 +0000

oclgrind (15.5-2) unstable; urgency=low

  * Fix a couple of compiler warnings.
  * Add Python to build dependencies to enable test suite.
  * Patch cl.h to fix build with -maltivec.  (Closes: #806965)

 -- James Price <j.price@bristol.ac.uk>  Mon, 07 Dec 2015 23:56:09 +0100

oclgrind (15.5-1) unstable; urgency=low

  * Initial release (Closes: #794787)

 -- James Price <j.price@bristol.ac.uk>  Sat, 12 Sep 2015 18:21:54 +0100
