=== debian/control ===
Source: oclgrind
Section: devel
Priority: optional
Maintainer: Debian OpenCL Maintainers <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders:
 James Price <j.price@bristol.ac.uk>,
Build-Depends:
 debhelper (>= 9),
 dh-exec (>= 0.3),
 cmake (>= 2.8.12),
 llvm-3.6-dev,
 libclang-3.6-dev,
 clang-3.6,
 libedit-dev,
 zlib1g-dev,
 libreadline-dev,
 opencl-headers,
 python (>= 2.7),
Standards-Version: 3.9.6
Homepage: https://github.com/jrprice/Oclgrind
Vcs-Git: git://anonscm.debian.org/pkg-opencl/oclgrind.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-opencl/oclgrind.git

Package: liboclgrind-15.5
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: core library for Oclgrind
 Oclgrind is an extensible OpenCL device simulator that provides a
 plugin interface to facilitate the creation of tools to aid analysis
 and development of OpenCL programs. Among the tools that Oclgrind
 provides are various debugging aids, such as out-of-bounds memory
 access checking, data-race detection, and an interactive debugger.
 .
 This package provides the core library for Oclgrind, implementing the
 simulator, plugin interface, and providing several built-in plugins.

Package: liboclgrind-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, liboclgrind-15.5 (= ${binary:Version})
Description: development files for Oclgrind
 Oclgrind is an extensible OpenCL device simulator that provides a
 plugin interface to facilitate the creation of tools to aid analysis
 and development of OpenCL programs. Among the tools that Oclgrind
 provides are various debugging aids, such as out-of-bounds memory
 access checking, data-race detection, and an interactive debugger.
 .
 This package provides the development headers and libraries used for
 creating new Oclgrind plugins.

Package: oclgrind
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, liboclgrind-15.5
Description: OpenCL device simulator
 Oclgrind is an extensible OpenCL device simulator that provides a
 plugin interface to facilitate the creation of tools to aid analysis
 and development of OpenCL programs. Among the tools that Oclgrind
 provides are various debugging aids, such as out-of-bounds memory
 access checking, data-race detection, and an interactive debugger.
 .
 Oclgrind implements the OpenCL 1.2 runtime API, which makes
 simulating an existing OpenCL program very straightforward - simply
 prefix your usual application command-line with 'oclgrind'. There is
 also a simple interface for simulating individual kernels in
 isolation via the 'oclgrind-kernel' command.
