=== debian/watch ===
version=3

https://github.com/jrprice/Oclgrind/releases /jrprice/Oclgrind/releases/download/v.*/Oclgrind-(.*)-Source\.tgz
