=== debian/changelog ===
oclgrind (16.10-3) unstable; urgency=low

  * Fix signed char issue causing several test failures

 -- James Price <j.price@bristol.ac.uk>  Fri, 20 Jan 2017 10:41:03 +0000

oclgrind (16.10-2) unstable; urgency=low

  * Fix armhf test failures (Closes: #851828)
  * Fix test failures on big-endian systems

 -- James Price <j.price@bristol.ac.uk>  Thu, 19 Jan 2017 13:05:47 +0000

oclgrind (16.10-1) unstable; urgency=low

  * New upstream release
  * Refresh patches, drop those applied upstream
  * Update to LLVM/Clang 3.9

 -- James Price <j.price@bristol.ac.uk>  Fri, 13 Jan 2017 02:34:56 +0100

oclgrind (15.5-6) unstable; urgency=low

  * Fix clc.h timestamp breaking PCH

 -- James Price <j.price@bristol.ac.uk>  Thu, 06 Oct 2016 23:14:10 +0100

oclgrind (15.5-5) unstable; urgency=low

  * Add support for LLVM 3.8 (Closes: #836610)
  * Build-depends on opencl-c-headers instead of opencl-headers

 -- James Price <j.price@bristol.ac.uk>  Sat, 01 Oct 2016 13:05:46 +0100

oclgrind (15.5-4) unstable; urgency=low

  * Fix isnan/isinf usasge for libc 2.23 (Closes: #818823)
  * Make constant data handling endian agnostic
  * Bump Standards-Version to 3.9.8
  * Use https:// for Vcs-Git field
  * Enable all hardening options

 -- James Price <j.price@bristol.ac.uk>  Mon, 02 May 2016 14:23:23 +0100
