=== debian/control ===
--- 
+++ 
@@ -8,20 +8,20 @@
  debhelper (>= 9),
  dh-exec (>= 0.3),
  cmake (>= 2.8.12),
- llvm-3.6-dev,
- libclang-3.6-dev,
- clang-3.6,
+ llvm-3.9-dev,
+ libclang-3.9-dev,
+ clang-3.9,
  libedit-dev,
  zlib1g-dev,
  libreadline-dev,
- opencl-headers,
+ opencl-c-headers,
  python (>= 2.7),
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: https://github.com/jrprice/Oclgrind
-Vcs-Git: git://anonscm.debian.org/pkg-opencl/oclgrind.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-opencl/oclgrind.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-opencl/oclgrind.git
 
-Package: liboclgrind-15.5
+Package: liboclgrind-16.10
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -39,7 +39,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: ${misc:Depends}, liboclgrind-15.5 (= ${binary:Version})
+Depends: ${misc:Depends}, liboclgrind-16.10 (= ${binary:Version})
 Description: development files for Oclgrind
  Oclgrind is an extensible OpenCL device simulator that provides a
  plugin interface to facilitate the creation of tools to aid analysis
@@ -53,7 +53,7 @@
 Package: oclgrind
 Architecture: any
 Multi-Arch: foreign
-Depends: ${shlibs:Depends}, ${misc:Depends}, liboclgrind-15.5
+Depends: ${shlibs:Depends}, ${misc:Depends}, liboclgrind-16.10
 Description: OpenCL device simulator
  Oclgrind is an extensible OpenCL device simulator that provides a
  plugin interface to facilitate the creation of tools to aid analysis
