=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,7 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
+export DEB_BUILD_MAINT_OPTIONS  = hardening=+all
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 DPKG_EXPORT_BUILDFLAGS = 1
@@ -13,7 +14,7 @@
 
 override_dh_auto_configure:
 	if [ -d src/CL ]; then mv src/CL src/CL-Do-Not-Use ; fi
-	dh_auto_configure -- -DLLVM_DIR=/usr/share/llvm-3.6/cmake
+	dh_auto_configure -- -DLLVM_DIR=/usr/lib/llvm-3.9/lib/cmake/llvm
 
 override_dh_auto_clean:
 	dh_auto_clean
